/* ̧قDoxygenpɏĂ܂B				 */
/**
 * \file
 *
 * \brief
 *		߲׌݊pͯ ̧
 *
 *		̧قIARGCC̗ł̺ތ݊ۏ؂邽߂̂̑SʓI
 *		Ȓ`ϸۂ܂݂܂B
 *
 * \par pLq:
 *		AVR1610: tinyAVR 1nłIEC 60730BKւ̎wj
 *
 * \par 
 *		IȺގAxׁ߲A߲אݒAx޲ɂĂ
 *		readme.htmlB
 *
 * \author
 *		Microchip Technology: http://www.microchip.com
 *		http://www.microchip.com/support/ł̎x
 *
 * 쌠 (C) 2017 Microchip Technology. s
 *
 * \page 
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. Microchip̖̂͐ɏꂽ̎wȂɂ̿ĳh̑
 *	  i◠(ۏ)ɎgpłȂ܂B
 *
 * 4. ̿ĳMicrochipAVRiƂ̊֌WłĕzĎgp邱Ƃł
 *	  ܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * MicrochipɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂
 * mɕ܂BƂ̂悤ȑQ̉\iꂽƂ
 * ĂA{gpłȂA܂͎gpȊOŔ(̑AƒfA
 * ܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRARA
 * ʁA܂͕tċN@Ȃ鑹Qɑ΂ĂMicrochipɐӔC
 * Ȃł傤B
 */

#ifndef COMPILER_AVR_H
#define COMPILER_AVR_H

#include <stdint.h>
#include <stdbool.h>
#include <stdlib.h>

#ifndef F_CPU
# define F_CPU 3333333
#endif

#define STRINGIZE_AUX(X) #X
#define STRINGIZE(X) STRINGIZE_AUX(X)
#define CONCAT(X,Y,Z) X##Y##Z
#define LABEL(X,Y,Z) CONCAT(X,Y,Z)

/** ϸۂ͈ȍ~̺ނ荞݂ی삵܂B */
#define ENTER_CRITICAL_REGION() uint8_t volatile saved_sreg = SREG; \
				cli();
#define REENTER_CRITICAL_REGION() saved_sreg = SREG; \
				cli();

/** ϸۂ͊荞݂Ăы悤ɏENTER_CRITICAL_REGIONƋɎg
	Ȃ΂Ȃ܂B */
#define LEAVE_CRITICAL_REGION() SREG = saved_sreg;

#if defined(__ICCAVR__)

#include <inavr.h>
#include <ioavr.h>
#include <intrinsics.h>
#include <pgmspace.h>

#ifndef __HAS_ELPM__
#define _MEMATTR  __flash
#else /* __HAS_ELPM__ */
#define _MEMATTR  __farflash
#endif /* __HAS_ELPM__ */

#define cpu_sleep() __sleep()

#define delay_us( us )   __delay_cycles((F_CPU / 1000000UL) * (us))

/**
 * ̑OIAR߲חp荞ݏٰݐ錾ͯ ْ̧ۉ
 * ߂Ɋs܂BISRpɈӂ̊֐\z邾łȂ
 * ޸蓖Ă邱Ƃ̗s߂ɁA2̈قȂ鐅̑OA
 * łȂA(ϸےuƂĎgƂłȂÂ#pragmaނ)C99
 * _Pragma()^߂gƂKvłB
 *
 * ϸۂ̏ύX悤ƂȂłBȂ΁AقڑSĂ̎ނ
 * IAR޸ނ}ɔł傤B
 */
#define PRAGMA(x) _Pragma(#x)
#define ISR(vec) PRAGMA(vector=vec) __interrupt void handler_##vec(void)
#define sei() (__enable_interrupt( ))
#define cli() (__disable_interrupt( ))

#define nop() (__no_operation())

#define INLINE PRAGMA(inline=forced) static

#define ASSEMBLY(x) __asm(x)

#define PROGMEM_LOCATION(var, loc) const _MEMATTR var @ loc
#define PROGMEM_DECLARE(x) _MEMATTR x
#define PROGMEM_STRING(x) ((_MEMATTR const char *)(x))
#define PROGMEM_STRING_T  char const _MEMATTR *
#define PROGMEM_T const _MEMATTR
#define PROGMEM_PTR_T const _MEMATTR *
#define PROGMEM_BYTE_ARRAY_T uint8_t const _MEMATTR *
#define PROGMEM_WORD_ARRAY_T uint16_t const _MEMATTR *
#define PROGMEM_READ_BYTE(x) *(x)
#define PROGMEM_READ_WORD(x) *(x)
#define PROGMEM_READ_DWORD(x) *(x)
#define PROGMEM_READ_BYTE_FAR(x) *((uint8_t __farflash*)x)
#define PROGMEM_READ_WORD_FAR(x) *((uint16_t __farflash*)x)
#define PROGMEM_READ_DWORD_FAR(x) *((uint32_t __farflash*)x)

#define NO_INIT __no_init

#define EEPROM_DECLARE(var) __eeprom var
#define EEGET(var, adr) __EEGET(var, adr)
#define EEPUT(adr, val) __EEPUT(adr, val)

#define watchdog_reset() __watchdog_reset()

#define SHORTENUM /**/


#elif defined(__GNUC__)

#include <avr/sleep.h>
#include <avr/io.h>
#include <avr/interrupt.h>
#include <avr/pgmspace.h>
//#include <avr/eeprom.h>		// XMEGAɑ΂ėps
#include <avr/wdt.h>
#include <util/delay.h>

#define cpu_sleep() sleep_cpu()

#define delay_us(us)   (_delay_us( us ))

#define INLINE static inline

#define ASSEMBLY __asm__ __volatile__

#define nop()   do {__asm__ __volatile__ ("nop");} while (0)

#define PROGMEM_LOCATION(var, loc) var __attribute__((section (#loc)))
#define PROGMEM_DECLARE(x) x __attribute__((__progmem__))
#define PROGMEM_STRING(x) PSTR(x)
#define PROGMEM_STRING_T  PGM_P
#define PROGMEM_T
#define PROGMEM_PTR_T *
#define PROGMEM_BYTE_ARRAY_T uint8_t*
#define PROGMEM_WORD_ARRAY_T uint16_t*
#define PROGMEM_READ_BYTE(x) pgm_read_byte(x)
#define PROGMEM_READ_WORD(x) pgm_read_word(x)
#define PROGMEM_READ_DWORD(x) pgm_read_dword(x)

#define PROGMEM_READ_BYTE_FAR(x) pgm_read_byte_far(x)
#define PROGMEM_READ_WORD_FAR(x) pgm_read_word_far(x)
#define PROGMEM_READ_DWORD_FAR(x) pgm_read_dword_far(x)

#define NO_INIT __attribute__ ((section (".noinit")))

// ̒`̂<avr/eeprom.h>ɗR܂B
//#define EEPROM_DECLARE(var) var EEMEM
#define EEPROM_DECLARE(var) var __attribute__((section(".eeprom")))
//#define EEGET(var, addr) (var) = eeprom_read_byte ((uint8_t *)(addr))
//#define EEPUT(addr, var) eeprom_write_byte ((uint8_t *)(addr), var)

#define watchdog_reset() wdt_reset()

#define SHORTENUM __attribute__ ((packed))
#else
#error Compiler not supported.
#endif

#endif // COMPILER_AVR_H
