/* ̧قDoxygenpɏĂ܂B				 */
/**
 * \file
 *
 * \version 1.0
 *
 * \brief Tiny817 XPROłOLED1 Xplainedgp̂߂ϸ
 *
 * \par pLq:
 *		AVR1610: tinyAVR 1nłIEC 60730BKւ̎wj
 *
 * \par 
 *		IȺގAxׁ߲A߲אݒAx޲ɂĂ
 *		readme.htmlB
 *
 * \author
 *		Microchip Technology: http://www.microchip.com
 *		http://www.microchip.com/support/ł̎x
 *
 * 쌠 (C) 2017 Microchip Technology. s
 *
 * \page 
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. Microchip̖̂͐ɏꂽ̎wȂɂ̿ĳh̑
 *	  i◠(ۏ)ɎgpłȂ܂B
 *
 * 4. ̿ĳMicrochipAVRiƂ̊֌WłĕzĎgp邱Ƃł
 *	  ܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * MicrochipɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂
 * mɕ܂BƂ̂悤ȑQ̉\iꂽƂ
 * ĂA{gpłȂA܂͎gpȊOŔ(̑AƒfA
 * ܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRARA
 * ʁA܂͕tċN@Ȃ鑹Qɑ΂ĂMicrochipɐӔC
 * Ȃł傤B
 */

/**
 * OLED1 XplainedLEDƖtA Tiny817 XPROEXT1ł̐ڑ:
 * LED1 - ݔԍ: 7 - Low - PB0
 * LED2 - ݔԍ: 8 - Low - PB1
 * LED3 - ݔԍ: 6 - Low - PB4
 * t1  - ݔԍ: 9 - Low - PA5
 * t2  - ݔԍ: 3 - Low - PA6
 * t3  - ݔԍ: 4 - Low - PA7
 */

#ifndef TINY817XPRO_H
#define TINY817XPRO_H

#include <avr/io.h>

// LED߰Ă
#define LED1_PORT		VPORTB
#define LED1_PIN		PIN0_bm
#define LED2_PORT		VPORTB
#define LED2_PIN		PIN1_bm
#define LED3_PORT		VPORTB
#define LED3_PIN		PIN4_bm

// t߰Ă
#define BUTTON1_PORT	PORTA
#define BUTTON1_PIN		PIN5_bm
#define BUTTON2_PORT	PORTA
#define BUTTON2_PIN		PIN6_bm
#define BUTTON3_PORT	PORTB
#define BUTTON3_PIN		PIN7_bm

// LEDON/OFFϸ
#define LED1_ON			LED1_PORT.OUT &= ~LED1_PIN
#define LED1_OFF		LED1_PORT.OUT |=  LED1_PIN
#define LED2_ON			LED2_PORT.OUT &= ~LED2_PIN
#define LED2_OFF		LED2_PORT.OUT |=  LED2_PIN
#define LED3_ON			LED3_PORT.OUT &= ~LED3_PIN
#define LED3_OFF		LED3_PORT.OUT |=  LED3_PIN

// LED1݂o͂ƂĐݒ肵LED1ONɐݒ
static inline void configure_LED1(void)
{
	LED1_ON;
	LED1_PORT.DIR |= LED1_PIN;
}

// LED2݂o͂ƂĐݒ肵LED2ONɐݒ
static inline void configure_LED2(void)
{
	LED2_ON;
	LED2_PORT.DIR |= LED2_PIN;
}

// LED3݂o͂ƂĐݒ肵LED3ONɐݒ
static inline void configure_LED3(void)
{
	LED3_ON;
	LED3_PORT.DIR |= LED3_PIN;
}

// t1݂ٱߕtA~[Ŋ荞݂ɍ\ݒ
static inline void configure_button1(void)
{
	BUTTON1_PORT.PIN5CTRL = PORT_PULLUPEN_bm | PORT_ISC_FALLING_gc;
}

// t2݂ٱߕtA~[Ŋ荞݂ɍ\ݒ
static inline void configure_button2(void)
{
	BUTTON2_PORT.PIN6CTRL = PORT_PULLUPEN_bm | PORT_ISC_FALLING_gc;
}

// t3݂ٱߕtA~[Ŋ荞݂ɍ\ݒ
static inline void configure_button3(void)
{
	BUTTON3_PORT.PIN7CTRL = PORT_PULLUPEN_bm | PORT_ISC_FALLING_gc;
}

#endif /*TINY817XPRO_H*/
